<?php
// kokudotile.php 電子国土KML低俯角対応版 Y.Nishioka, 2013-05-08
$zmin = 5;                         // ズームレベル最小値値
$zmax = 18;                        // ズームレベル最大値
$z = $_GET['z'];
$y = $_GET['y'];
$x = $_GET['x'];

// $_GET入力値の妥当性チェック
if ( !ctype_digit($x.$y.$z) ) {
	header('HTTP/1.1 400 Bad Request');
	exit();
}

// $x, $y, $zに対応するタイル画像のURLを返す
// 他のタイルマップに応用するときは個の関数を書き換える
function getImgUrl($x, $y, $z) {
	if ( $z<9 ) {
		$dataset = 'JAIS';
    } else if ( $z<12 ) {
    	$dataset = 'BAFD1000K';
	    //$dataset = 'RELIEF';
    } else if ( $z<15 ) {
		$dataset = 'BAFD200K';
	} else if ( $z<18 ) {
		$dataset = 'DJBMM';
	} else {
		$dataset = 'FGD';
	};
	$base = 'http://cyberjapandata.gsi.go.jp/sqras/all/'.$dataset.'/latest/';
	$xs = substr('0000000'.$x, -7);
	$ys = substr('0000000'.$y, -7);
	$img = $base.$z.'/'.$xs[0].$ys[0].'/'.$xs[1].$ys[1].'/'.$xs[2].$ys[2].'/';
	$img.= $xs[3].$ys[3].'/'.$xs[4].$ys[4].'/'.$xs[5].$ys[5].'/'.$xs.$ys.'.png';
	return $img;
}

$pro = ( $_SERVER['HTTPS']=='on' ) ? 'https://' : 'http://'; 
$phppath = $pro.$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'].'?z='.($z+1).'&';
	
$n = htmlspecialchars(asin(tanh((0.5 - $y/pow(2,$z))*2*pi()))/(2*pi())*360);
$s = htmlspecialchars(asin(tanh((0.5 - ($y+1)/pow(2,$z))*2*pi()))/(2*pi())*360);
$w = htmlspecialchars($x/pow(2,$z)*360-180);
$e = htmlspecialchars(($x+1)/pow(2,$z)*360-180);

// kml出力開始
echo '<?xml version="1.0" encoding="UTF-8"?>';
echo '<kml xmlns="http://www.opengis.net/kml/2.2">';
echo '<Document>';
echo '<name>z='.htmlspecialchars($z).'</name>';
echo '<Folder>';
echo '<Region>';
echo '<LatLonAltBox>';
echo '<north>'.($n).'</north><south>'.($s).'</south>';
echo '<east>'.($e).'</east><west>'.($w).'</west>';
echo '</LatLonAltBox>';
echo '<Lod>';
echo $z > $zmin+1 ? '<minLodPixels>128</minLodPixels>' : '';
echo $z < $zmax-1 ? '<maxLodPixels>512</maxLodPixels>' : '';
echo '</Lod>';
echo '</Region>';
echo '<GroundOverlay>';
echo '<Icon><href>'.htmlspecialchars(getImgUrl($x, $y, $z)).'</href></Icon>';
echo '<LatLonBox>';
echo '<north>'.$n.'</north><south>'.$s.'</south>';
echo '<east>'.$e.'</east><west>'.$w.'</west>';
echo '</LatLonBox>';
echo '</GroundOverlay>';
echo '</Folder>';

if ( $z<$zmax ) {
	for ( $dx=0; $dx<2; $dx++ ){
		for ( $dy=0; $dy<2; $dy++ ){
			$linkhref = $phppath.'y='.($y*2+$dy).'&x='.($x*2+$dx);
			$e2 = htmlspecialchars($dx==0 ? ($e+$w)/2 : $e);
			$w2 = htmlspecialchars($dx==0 ? $w : ($e+$w)/2);
			$n2 = htmlspecialchars( $dy==0 ? $n : ($s+$n)/2);
			$s2 = htmlspecialchars($dy==0 ? ($s+$n)/2 : $s);
		    echo '<Folder>';
   			echo '<Region>';
		    echo '<LatLonAltBox>';
   			echo '<north>'.($n2).'</north><south>'.($s2).'</south>';
		    echo '<east>'.($e2).'</east><west>'.($w2).'</west>';
   			echo '</LatLonAltBox>';
	    	echo '<Lod><minLodPixels>128</minLodPixels></Lod>';
   			echo '</Region>';
	    	echo '<NetworkLink><Link>';
	    	echo '<href>'.htmlspecialchars($linkhref).'</href>';
   			echo '</Link></NetworkLink>';
    		echo '</Folder>';
		}
	}
}
?>
  </Document>
</kml>
